<?php
// cpmrun.php  Script to be included in a web page - for example Wordpress - to  
// display a grid of static images. The configuration of these is defined in a file which is read in,
// for example cpmfetch/inc/cpmfetchsetupxxx.inc.php  where xxx is any number of characters
// cpmfetch release 2.2   Newly introduced by KF 

function cpmrun($setupfilename="") {
// $setupfilename is the name of the setup file passed in. Just the file name with no directory.
// If blank, run standard static grid cpmfetch 
global $cpmfetchdir;
$cpmfetchphp = "cpmfetch.php";      // The main program file used 
$defaultsetupfilename = "cpmfetchsetup.inc.php";
$slideshowfile = "cpmslideshow.php";
$cpmfetchdir = __DIR__ . "/";       // This is the cpmfetch directory which will be used later in various require statements 
if ($setupfilename == "") {
    $setupfilename = $defaultsetupfilename;
    $rungrid = true;
    $runslide = false;
} else {
    $rungrid = (strpos($setupfilename, "cpmfetchsetup", 0) !== false);  // Does file name contain cpmfetchsetup ?
    $runslide = (strpos($setupfilename, "cpmslideshowsetup", 0) !== false);  // Does file name contain cpmslideshowsetup ?
    if ( !($rungrid || $runslide) ) {
        exit ("cpmrun.php: Invalid setup file name passed in: {$setupfilename}");
    }
}
$setupfilenameandpath = $cpmfetchdir . "inc/" . $setupfilename;     // Setup files are in the inc directory below the main cpmfetch
if ($rungrid) {           
    $cpmfetchmainfile = $cpmfetchdir . $cpmfetchphp;
    require($cpmfetchmainfile);                    // Pull in the main file cpmfetch.php
    $objCpm = new cpm("");    
    require($setupfilenameandpath);                 // Pull in the fetch setup file created by the user
    $objCpm->cpm_close();                       
} else if ($runslide) {
    $slideshowfileandpath = $cpmfetchdir . $slideshowfile;
    require($slideshowfileandpath);
    cpmprepareslideshow($setupfilenameandpath);
}

}
?>
