<?php

// testslideshow.php  Test program to test the CPMFETCH slideshow. 
// Run this program in a web browser using, for example https://www.yourdomain.com/gallery/cpmfetch/testslideshow.php
// cpmfetch release 2.2   Newly introduced by KF 
//
// There should be no need to change anything in this script as all the setup parameters are in an included file 
// Option 1) cpmslideshowsetup.inc.php  or  Option 2) cpmslideshowsetupxxx.inc.php    where xxx is any text but typically a number
// If cpmslideshowsetup.inc.php doesn't exist, program will look for all cpmslideshowsetupxxx.inc.php and user will be prompted

global $_GET, $cpmfetchdir;
$cpmfetchdir = __DIR__ . "/";       // This is the cpmfetch directory which will be used later in various require statements 
$default_setupfile = 'cpmslideshowsetup.inc.php';
$cpmslideshowcode = 'cpmslideshow.php';
$search_pattern = "cpmslideshowsetup*.inc.php";
$inc_directory = "./inc/";
if (array_key_exists('slideshowstpfile', $_GET)) {  // See if setup file name was passed in
    $slideshowstpfile = $_GET['slideshowstpfile'];
    $changesetupfile = <<<EOT
        <form id="cpmresetfile" action="testslideshow.php" method="get">
        <button type="submit" class="button" formmethod="get" style="text-align:center" value="yes" name="change">Change setup File</button>
        </form>
EOT;
} else {
    $slideshowstpfile = $default_setupfile;     // If not, use the default setup filename
    $changesetupfile = "";
}
// Beginning of simple HTML pages -------------------------------------------------------
$htmlpagehead = <<< EOT
    <!doctype html>
    <html>
    <head>
    <title>CPM Test Slideshow Page</title>
    <meta name="CPM Test Slideshow Page" content="Main page">
    </head>
    <body> 
    <B>Test Program for cpmslideshow</B> - testslideshow.php<br>
EOT;


$htmlpage2 = <<< EOT
    </body>
    <p>End of cpmslideshow test program</p>
    </html>
EOT;
// End of simple HTML pages -------------------------------------------------------------
$slideshowstpfilewithdir = $inc_directory . $slideshowstpfile;     // Reach down into the /inc directory for these files
if (file_exists($slideshowstpfilewithdir)) {  // setup name either passed in or default is used. If it doesn't exist, ask for it
 
    echo $htmlpagehead;        // Display the beginning of the simple page
    testslidestart($slideshowstpfilewithdir, $changesetupfile);
    require($cpmslideshowcode);             // This contains the slide show code to be run 
    cpmprepareslideshow($slideshowstpfilewithdir);  
    testslideend($htmlpage2);
           
} else {
    $linebreak = "\r\n";
    $htmllinebreak = "<br>";
    $fullsearch = $inc_directory . $search_pattern;
    $file_array = glob($fullsearch);
    $output_option = array();
    $i = 0;
    if ($file_array) {          // If the file array exists  i.e. some files were found  
        echo $htmlpagehead;        // Display the beginning of the simple page
        echo "<table width=\"70%\">";
        echo '<form id="cpgfetchfile" action="testslideshow.php" method="get">';
        echo "Choose setup File";
        foreach ($file_array as $cpmincfile) {
            $i++;
            $cpmincfile = basename($cpmincfile);            // Strip out directory leaving just the filename
            $output_option[$i] = ($i==1) ? "checked=\"checked\"" : "";  // Radio button selected always defaults to file 1
            echo <<<EOT
                <tr>
                    <td class="tableb" width="30%">
                        <label for="slideshowstpfile" class="clickable_option">File {$i}: {$cpmincfile}</label>
                    </td>
                    <td class="tableb" colspan="1">
                        <input type="radio" name="slideshowstpfile" id="cpmfetch_file{$i}" class="radio" value="{$cpmincfile}" {$output_option[$i]}/>
                        <label for="cpmfetch_file{$i}" class="clickable_option"></label>
                    </td>
                </tr>
EOT;
        }

        echo <<<EOT
            <tr>
                <td class="tableb" width="50%">
                </td>
                <td class="tablef" colspan="2">
                    <button type="submit" class="button" formmethod="get" style="text-align:center" name="">Submit</button>
                    </form>
                </td>
            </tr>
EOT;

        echo $htmlpage2;
        echo "</table>";
        
    } else {
        echo "No files found matching " . $search_pattern . " in directory " . getcwd() . $inc_directory . $htmllinebreak;
    }
}
//-----------------------------
    function testslidestart($slideshowstpfile, $changesetupfile) {
        $this_file = file_get_contents($slideshowstpfile);   // Read in this file so we can extract the cpfmfetch commands and display them
        $slideshowstpfile = basename($slideshowstpfile);    // Remove any directory from the filename passed in so the messages are cleaner
        if (!$this_file) {
            echo "testslideshow.php: File containing setup code to be tested was not found";
            exit;
        } else {
            $pattern = "#\/\/= Start(.*?)//= End#s";
            preg_match($pattern, $this_file, $userblock);   // Extract the whole block between the markers containing the cpfmfetch commands
            if (isset($userblock)) {                // Check that the code block was found. Problem if not
                $cpmfetch_commands = '';
                $code_array = preg_split("/\r\n|\n|\r/", $userblock[0]); // Convert code block into array of strings
                foreach ($code_array as $element) {      // Run through the array of code 
                    if ($element <> "") {                 // ignore blank lines
                        $len = strlen($element);
                        $search_length = ($len < 5) ? $len : 5;   // Use length of string if less than 5 chars, or 5 chars
                        // Search the first five or less characters in the line for the comment delimiter. If not there, build variable containing just the cpmfetch commands
                        if (substr_count($element, "//", 0, $search_length) == 0)   $cpmfetch_commands .= $element . '<br>';     
                    }
                }
            } else {
                echo "testslideshow.php: Block of setup code not found in {$slideshowstpfile}";
                exit;
            }
        $htmlpage1 = <<< EOT
            The setup file is: <code>{$slideshowstpfile}</code>
            {$changesetupfile}
            The commands used were:<br>
            <pre>{$cpmfetch_commands}</pre>
            If the cpmfetch commands have found some pictures the slideshow will appear below between the two lines. <br>
            <hr>
        EOT;
        echo $htmlpage1;   
        }
    } // End testslidestart
//-----------------------------
    function testslideend($endhtmlcode) {
    // Display end of page 
        echo "<hr>";
        echo $endhtmlcode;
    } // End testslideend
//-----------------------------   

?>





